#!/usr/bin/python
#
#    IBM Omni driver
#    Copyright (c) International Business Machines Corp., 2000-2004
#
#    This library is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation; either version 2.1 of the License, or
#    (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
#    the GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public License
#    along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

from Utils import *

class DeviceCommands:
    def __init__ (self, filename, rootElement):
        print 'Parsing "%s"' % filename

        self.filename    = filename
        self.rootElement = rootElement
        self.commands    = []

        error = self.isValid ()
        if error != None:
            e = "Error: '%s' is not a valid device. %s" % (filename, error)
            raise Exception, e

    def isValid (self):
#       print self.__class__.__name__ + ".isValid"

        elmCommands = self.rootElement

        if elmCommands.nodeName != "deviceCommands":
            return "Missing <deviceCommands>, found " + elmCommands.nodeName

        if countChildren (elmCommands) < 1:
            return "At least one <command> element is required"

        elmCommand  = firstNode (elmCommands.firstChild)
        elmCommands = nextNode (elmCommands)

        while elmCommand != None:
            if elmCommand.nodeName != "command":
                return "Missing <command>, found " + elmCommand.nodeName

            attr = elmCommand.attributes.getNamedItem ("name")
            if attr == None:
                return "Missing name= attribute in <command>"

            name       = attr.nodeValue
            command    = getCommand (elmCommand)
            elmCommand = nextNode (elmCommand)

            self.commands.append ((name, command))

        if elmCommands != None:
            return "Expecting no more tags in <deviceCommands>"

        return None

    def getCommands (self):
        return self.commands
